/**
 * AJAX需要修改页面的方法
 * @param url  #->请求的URL地址
 * @param str  #->请求的字符串
 * @param type #->请求的类型
 * @param divid #->修改哪个ID层的内容
 * @returns {Boolean}
 */

 function qingxinzui_zuowei(url,str,type,divid) //提交数据按钮
 {
 	var ajax=false;
 	str=str+"&type="+type;
 	if(window.XMLHttpRequest) {
 		ajax = new XMLHttpRequest();
 		if (ajax.overrideMimeType) {
 			ajax.overrideMimeType("text/xml");
 			}
 		}
 	else if (window.ActiveXObject) {
 		try {
 			ajax = new ActiveXObject("Msxml2.XMLHTTP");
 			} catch (e) {
 				try {
 					ajax = new ActiveXObject("Microsoft.XMLHTTP");
 					} catch (e) {}
 					}
 			}
 	if (!ajax) {
 		window.alert("不能创建XMLHttpRequest对象实例.");
 		return false;
 		}

 	ajax.open("POST", url, true);
 	ajax.setRequestHeader("cache-control","no-cache");
 	ajax.setRequestHeader("contentType","text/html;charset=uft-8");
 	ajax.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
 	ajax.send(str);
 	ajax.onreadystatechange = function()
 	{
 		if (ajax.readyState == 4 && ajax.status == 200) {
 			document.getElementById(divid).innerHTML=ajax.responseText;
 		}else {
 		}
 	}
 }
 
 
 /**
  * AJAX需要弹出窗口的方法
  * @param url
  * @param str
  * @param type
  * @param divid
  * @returns {Boolean}
  */
 function qingxinzui_alert(url,str,type) //提交数据按钮
 {
 	var ajax=false;
 	str=str+"&type="+type;
 	if(window.XMLHttpRequest) {
 		ajax = new XMLHttpRequest();
 		if (ajax.overrideMimeType) {
 			ajax.overrideMimeType("text/xml");
 			}
 		}
 	else if (window.ActiveXObject) {
 		try {
 			ajax = new ActiveXObject("Msxml2.XMLHTTP");
 			} catch (e) {
 				try {
 					ajax = new ActiveXObject("Microsoft.XMLHTTP");
 					} catch (e) {}
 					}
 			}
 	if (!ajax) {
 		window.alert("不能创建XMLHttpRequest对象实例.");
 		return false;
 		}

 	ajax.open("POST", url, true);
 	ajax.setRequestHeader("cache-control","no-cache");
 	ajax.setRequestHeader("contentType","text/html;charset=uft-8");
 	ajax.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
 	ajax.send(str);
 	ajax.onreadystatechange = function()
 	{
 		if (ajax.readyState == 4 && ajax.status == 200) {
 			alert(ajax.responseText);
 			window.location.reload();
 		}else {
 		}
 	}
 }
 
 
 function qingxinzui_return(url,str)
 {
 	var ajax=false;
 	if(window.XMLHttpRequest) {
 		ajax = new XMLHttpRequest();
 		if (ajax.overrideMimeType) {
 			ajax.overrideMimeType("text/xml");
 			}
 		}
 	else if (window.ActiveXObject) {
 		try {
 			ajax = new ActiveXObject("Msxml2.XMLHTTP");
 			} catch (e) {
 				try {
 					ajax = new ActiveXObject("Microsoft.XMLHTTP");
 					} catch (e) {}
 					}
 			}
 	if (!ajax) {
 		window.alert("不能创建XMLHttpRequest对象实例.");
 		return false;
 		}

 	ajax.open("POST", url, true);
 	ajax.setRequestHeader("cache-control","no-cache");
 	ajax.setRequestHeader("contentType","text/html;charset=uft-8");
 	ajax.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
 	ajax.send(str);
 	ajax.onreadystatechange = function()
 	{
 		if (ajax.readyState == 4 && ajax.status == 200) {
 			return ajax.responseText;
 		}else {
 		}
 	}
 }